<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 */
class PackageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('packages'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image' => 'sometimes|required_if:video_type,2',
            'images.*' => 'sometimes',
            'package_category_id' => 'required',
            'video' => 'sometimes|required_if:video_type,2',
            'video_url' => 'sometimes|url|nullable|required_if:video_type,1',
            'video_type' => 'sometimes|nullable',
            'user_id' => 'required'
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required|min:3',
                'slug_'.$lang->local=> [
                    "required",
                    Rule::unique('package_descriptions', 'slug')->ignore($this->package? $this->package->id : 0, 'package_id')
                ],
                'keywords_'.$lang->local=> 'required|min:3',
                'meta_description_'.$lang->local=> 'required|min:3',
                'description_'.$lang->local=> 'required|min:3',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('packages');
        $local = getCurrentLocale();
        $attributes=[
            'video' => metaFields('packages', 'video', $local),
            'video_url' => metaFields('packages', 'video_url', $local),
            'image' => metaFields('packages', 'image', $local),
            'video_type' => metaFields('packages', 'video_type', $local),
            'package_category_id' =>  metaFields('packages', 'package_category_id', $local) ??__('packages.category'),
            'other_image' => __('packages.other_image')
        ];


        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => $field[$lang->local]['title'] ?? __('packages.title'),
                'slug_'.$lang->local =>  $field[$lang->local]['slug'] ?? __('packages.slug'),
                'keywords_'.$lang->local => $field[$lang->local]['keywords'] ?? __('packages.keywords'),
                'meta_description_'.$lang->local=> $field[$lang->local]['meta_description'] ?? __('packages.meta_description'),
                'description_'.$lang->local=> $field[$lang->local]['description'] ?? __('packages.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
